<template>
  <v-form ref="form" v-model="valid" lazy-validation>
    <v-text-field
      v-model="address.street"
      outlined
      required
      label="Street"
      :rules="rules"
    ></v-text-field>
    <v-text-field
      v-model="address.postalCode"
      outlined
      required
      label="Postal code"
      :rules="rules"
    ></v-text-field>
    <v-text-field
      v-model="address.city"
      outlined
      required
      label="City"
      :rules="rules"
    ></v-text-field>
    <v-text-field
      v-model="address.country"
      outlined
      required
      label="Country"
      :rules="rules"
    ></v-text-field>
    <v-btn @click="clear">Clear</v-btn>
    <v-btn color="primary" :disabled="!valid" @click="submit">Add</v-btn>
  </v-form>
</template>

<script lang="ts">
import Vue from 'vue'

export default Vue.extend({
  data() {
    return {
      valid: true,
      address: {
        street: '',
        postalCode: '',
        city: '',
        country: '',
      },
      rules: [(v: string) => !!v || 'This field is required'],
    }
  },
  methods: {
    clear(): void {
      ;(this.$refs.form as any).reset()
    },
    submit(): void {
      if ((this.$refs.form as any).validate()) {
        this.$axios.$post('http://delivery.localhost:4000/addresses', {
          ...this.address,
          ownerType: 'deliverer',
          owner: this.$store.state.loggedIn, // ! user
        })

        this.$router.push('/account/addresses')
      }
    },
  },
})
</script>
